<?php
class Bitfoundry_Etnpay_Model_Pay extends Mage_Payment_Model_Method_Abstract
{
    protected $_code = 'bitfoundryetnpay';
    protected $_formBlockType = 'bitfoundryetnpay/form_pay';
    protected $_infoBlockType = 'bitfoundryetnpay/info_pay';
    protected $_canCapture = true;

    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('bitfoundryetnpay/processing/redirect', array('_secure' => false));
    }
    
    public function getVendorAddress($storeId = 0) {
        if ($storeId == 0)
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_address');
        else
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_address', $storeId);
    }
    
    public function getApiKey($storeId = 0) {
        if ($storeId == 0)
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_key');
        else
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_key', $storeId);
    }
    
    public function getApiSecret($storeId = 0) {
        if ($storeId == 0)
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_secret');
        else
            return Mage::getStoreConfig('payment/bitfoundryetnpay/vendor_secret', $storeId);
    }
    
    public function getOrderStatus() {
        return $this->getConfigData('order_status');
    }

    public function getOrderPlacedEmail() {
        return $this->getConfigData('order_placed_email');
    }

    public function getOrderSuccessfulEmail() {
        return $this->getConfigData('order_successful_email');
    }

    public function getOrderFailedEmail() {
        return $this->getConfigData('order_failed_email');
    }

    public function getOrder() {
        $order = Mage::getModel('sales/order');
        $session = Mage::getSingleton('checkout/session');
        $order->loadByIncrementId($session->getLastRealOrderId());
        return $order;
    }
    
    // not used
    public function getOrderByElectroneumReference($orderRef) {
        $order = Mage::getModel('sales/order');
        $order->loadByIncrementId($orderRef);
        return $order;
    }
    
    public function getExpectedApiIp() {
        return Mage::getStoreConfig('payment/bitfoundryetnpay/expected_api_ip');
    }
}